Index: serefpolicy-contrib-20140730/puppet.if
===================================================================
--- serefpolicy-contrib-20140730.orig/puppet.if
+++ serefpolicy-contrib-20140730/puppet.if
@@ -1,4 +1,32 @@
-## <summary>Configuration management system.</summary>
+## <summary>Puppet client daemon</summary>
+## <desc>
+##	<p>
+##	Puppet is a configuration management system written in Ruby.
+##	The client daemon is responsible for periodically requesting the
+##	desired system state from the server and ensuring the state of
+##	the client system matches.
+##	</p>
+## </desc>
+
+########################################
+## <summary>
+##	Execute puppet_master in the puppet_master
+##	domain.
+## </summary>
+## <param name="domain">
+## <summary>
+##	Domain allowed to transition.
+## </summary>
+## </param>
+#
+interface(`puppet_domtrans_master',`
+	gen_require(`
+		type puppetmaster_t, puppetmaster_exec_t;
+	')
+
+	corecmd_search_bin($1)
+	domtrans_pattern($1, puppetmaster_exec_t, puppetmaster_t)
+')
 
 ########################################
 ## <summary>
@@ -40,16 +68,19 @@ interface(`puppet_domtrans_puppetca',`
 #
 interface(`puppet_run_puppetca',`
 	gen_require(`
-		attribute_role puppetca_roles;
+		type puppetca_t, puppetca_exec_t;
 	')
 
 	puppet_domtrans_puppetca($1)
-	roleattribute $2 puppetca_roles;
+	role $2 types puppetca_t;
 ')
 
-####################################
+################################################
 ## <summary>
-##	Read puppet configuration content.
+##	Read / Write to Puppet temp files.  Puppet uses
+##	some system binaries (groupadd, etc) that run in
+##	a non-puppet domain and redirects output into temp
+##	files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -57,15 +88,13 @@ interface(`puppet_run_puppetca',`
 ##	</summary>
 ## </param>
 #
-interface(`puppet_read_config',`
+interface(`puppet_rw_tmp', `
 	gen_require(`
-		type puppet_etc_t;
+		type puppet_tmp_t;
 	')
 
-	files_search_etc($1)
-	allow $1 puppet_etc_t:dir list_dir_perms;
-	allow $1 puppet_etc_t:file read_file_perms;
-	allow $1 puppet_etc_t:lnk_file read_lnk_file_perms;
+	allow $1 puppet_tmp_t:file rw_inherited_file_perms;
+	files_search_tmp($1)
 ')
 
 ################################################
@@ -78,158 +107,164 @@ interface(`puppet_read_config',`
 ##	</summary>
 ## </param>
 #
-interface(`puppet_read_lib_files',`
+interface(`puppet_read_lib',`
 	gen_require(`
 		type puppet_var_lib_t;
 	')
 
-	files_search_var_lib($1)
 	read_files_pattern($1, puppet_var_lib_t, puppet_var_lib_t)
+	files_search_var_lib($1)
 ')
 
 ###############################################
 ## <summary>
-##	Create, read, write, and delete
-##	puppet lib files.
+##  Manage Puppet lib files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
-interface(`puppet_manage_lib_files',`
-	gen_require(`
-		type puppet_var_lib_t;
-	')
+interface(`puppet_manage_lib',`
+    gen_require(`
+        type puppet_var_lib_t;
+    ')
 
-	files_search_var_lib($1)
-	manage_files_pattern($1, puppet_var_lib_t, puppet_var_lib_t)
+    manage_files_pattern($1, puppet_var_lib_t, puppet_var_lib_t)
+    files_search_var_lib($1)
 ')
 
-#####################################
+######################################
 ## <summary>
-##	Append puppet log files.
+##  Allow the specified domain to search puppet's log files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
-interface(`puppet_append_log_files',`
-	gen_require(`
-		type puppet_log_t;
-	')
+interface(`puppet_search_log',`
+    gen_require(`
+        type puppet_log_t;
+    ')
 
-	logging_search_logs($1)
-	append_files_pattern($1, puppet_log_t, puppet_log_t)
+    logging_search_logs($1)
+    allow $1 puppet_log_t:dir search_dir_perms;
 ')
 
 #####################################
 ## <summary>
-##	Create puppet log files.
+##  Allow the specified domain to read puppet's log files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
-interface(`puppet_create_log_files',`
-	gen_require(`
-		type puppet_log_t;
-	')
+interface(`puppet_read_log',`
+    gen_require(`
+        type puppet_log_t;
+    ')
 
-	logging_search_logs($1)
-	create_files_pattern($1, puppet_log_t, puppet_log_t)
+    logging_search_logs($1)
+	read_files_pattern($1, puppet_log_t, puppet_log_t)
 ')
 
 #####################################
 ## <summary>
-##	Read puppet log files.
+##  Allow the specified domain to create puppet's log files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
-interface(`puppet_read_log_files',`
-	gen_require(`
-		type puppet_log_t;
-	')
+interface(`puppet_create_log',`
+    gen_require(`
+        type puppet_log_t;
+    ')
 
-	logging_search_logs($1)
-	read_files_pattern($1, puppet_log_t, puppet_log_t)
+    logging_search_logs($1)
+    create_files_pattern($1, puppet_log_t, puppet_log_t)
 ')
 
-################################################
+####################################
 ## <summary>
-##	Read and write to puppet tempoprary files.
+##  Allow the specified domain to append puppet's log files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
 #
-interface(`puppet_rw_tmp', `
-	gen_require(`
-		type puppet_tmp_t;
-	')
+interface(`puppet_append_log',`
+    gen_require(`
+        type puppet_log_t;
+    ')
 
-	files_search_tmp($1)
-	allow $1 puppet_tmp_t:file rw_file_perms;
+    logging_search_logs($1)
+    append_files_pattern($1, puppet_log_t, puppet_log_t)
 ')
 
-########################################
+####################################
 ## <summary>
-##	All of the rules required to
-##	administrate an puppet environment.
+##  Allow the specified domain to manage puppet's log files.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
-## </param>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed access.
+##  </summary>
 ## </param>
-## <rolecap/>
 #
-interface(`puppet_admin',`
-	gen_require(`
-		type puppet_initrc_exec_t, puppetmaster_initrc_exec_t, puppet_log_t;
-		type puppet_var_lib_t, puppet_tmp_t, puppet_etc_t;
-		type puppet_var_run_t, puppetmaster_tmp_t;
-		type puppet_t, puppetca_t, puppetmaster_t;
-	')
-
-	allow $1 { puppet_t puppetca_t puppetmaster_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { puppet_t puppetca_t puppetmaster_t })
-
-	init_labeled_script_domtrans($1, { puppet_initrc_exec_t puppetmaster_initrc_exec_t })
-	domain_system_change_exemption($1)
-	role_transition $2 { puppet_initrc_exec_t puppetmaster_initrc_exec_t } system_r;
-	allow $2 system_r;
+interface(`puppet_manage_log',`
+    gen_require(`
+        type puppet_log_t;
+    ')
 
-	files_search_etc($1)
-	admin_pattern($1, puppet_etc_t)
-
-	logging_search_logs($1)
-	admin_pattern($1, puppet_log_t)
+    logging_search_logs($1)
+    manage_files_pattern($1, puppet_log_t, puppet_log_t)
+')
 
-	files_search_var_lib($1)
-	admin_pattern($1, puppet_var_lib_t)
+####################################
+## <summary>
+##  Allow the specified domain to read puppet's config files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`puppet_read_config',`
+    gen_require(`
+        type puppet_etc_t;
+    ')
+
+    files_search_etc($1)
+	list_dirs_pattern($1, puppet_etc_t, puppet_etc_t)
+    read_files_pattern($1, puppet_etc_t, puppet_etc_t)
+')
 
+#####################################
+## <summary>
+##  Allow the specified domain to search puppet's pid files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`puppet_search_pid',`
+    gen_require(`
+        type puppet_var_run_t;
+    ')
+	
 	files_search_pids($1)
-	admin_pattern($1, puppet_var_run_t)
-
-	files_search_tmp($1)
-	admin_pattern($1, { puppet_tmp_t puppetmaster_tmp_t })
-
-	puppet_run_puppetca($1, $2)
+    allow $1 puppet_var_run_t:dir search_dir_perms;
 ')
Index: serefpolicy-contrib-20140730/puppet.te
===================================================================
--- serefpolicy-contrib-20140730.orig/puppet.te
+++ serefpolicy-contrib-20140730/puppet.te
@@ -1,4 +1,4 @@
-policy_module(puppet, 1.4.1)
+policy_module(puppet, 1.4.0)
 
 ########################################
 #
@@ -6,25 +6,32 @@ policy_module(puppet, 1.4.1)
 #
 
 ## <desc>
-##	<p>
-##	Determine whether puppet can
-##	manage all non-security files.
-##	</p>
+## <p>
+## Allow Puppet client to manage all file
+## types.
+## </p>
 ## </desc>
-gen_tunable(puppet_manage_all_files, false)
+gen_tunable(puppetagent_manage_all_files, false)
 
-attribute_role puppetca_roles;
-roleattribute system_r puppetca_roles;
+## <desc>
+## <p>
+## Allow Puppet master to use connect to MySQL and PostgreSQL database
+## </p>
+## </desc>
+gen_tunable(puppetmaster_use_db, false)
 
-type puppet_t;
-type puppet_exec_t;
-init_daemon_domain(puppet_t, puppet_exec_t)
+type puppetagent_t;
+type puppetagent_exec_t;
+typealias puppetagent_exec_t alias puppet_exec_t;
+typealias puppetagent_t alias puppet_t;
+init_daemon_domain(puppetagent_t, puppetagent_exec_t)
 
 type puppet_etc_t;
 files_config_file(puppet_etc_t)
 
-type puppet_initrc_exec_t;
-init_script_file(puppet_initrc_exec_t)
+type puppetagent_initrc_exec_t;
+typealias puppetagent_initrc_exec_t alias puppet_initrc_exec_t;
+init_script_file(puppetagent_initrc_exec_t)
 
 type puppet_log_t;
 logging_log_file(puppet_log_t)
@@ -37,12 +44,11 @@ files_type(puppet_var_lib_t)
 
 type puppet_var_run_t;
 files_pid_file(puppet_var_run_t)
-init_daemon_pid_file(puppet_var_run_t, dir, "puppet")
 
 type puppetca_t;
 type puppetca_exec_t;
 application_domain(puppetca_t, puppetca_exec_t)
-role puppetca_roles types puppetca_t;
+role system_r types puppetca_t;
 
 type puppetmaster_t;
 type puppetmaster_exec_t;
@@ -56,161 +62,156 @@ files_tmp_file(puppetmaster_tmp_t)
 
 ########################################
 #
-# Local policy
+# Puppet personal policy
 #
 
-allow puppet_t self:capability { chown fowner fsetid setuid setgid dac_override sys_admin sys_nice sys_tty_config };
-allow puppet_t self:process { signal signull getsched setsched };
-allow puppet_t self:fifo_file rw_fifo_file_perms;
-allow puppet_t self:netlink_route_socket create_netlink_socket_perms;
-allow puppet_t self:tcp_socket { accept listen };
-allow puppet_t self:udp_socket create_socket_perms;
+allow puppetagent_t self:capability { fowner fsetid setuid setgid dac_override sys_nice sys_tty_config };
+allow puppetagent_t self:process { signal signull getsched setsched };
+allow puppetagent_t self:fifo_file rw_fifo_file_perms;
+allow puppetagent_t self:netlink_route_socket create_netlink_socket_perms;
+allow puppetagent_t self:tcp_socket create_stream_socket_perms;
+allow puppetagent_t self:udp_socket create_socket_perms;
 
-allow puppet_t puppet_etc_t:dir list_dir_perms;
-allow puppet_t puppet_etc_t:file read_file_perms;
-allow puppet_t puppet_etc_t:lnk_file read_lnk_file_perms;
+read_files_pattern(puppetagent_t, puppet_etc_t, puppet_etc_t)
 
-manage_dirs_pattern(puppet_t, puppet_var_lib_t, puppet_var_lib_t)
-manage_files_pattern(puppet_t, puppet_var_lib_t, puppet_var_lib_t)
-can_exec(puppet_t, puppet_var_lib_t)
+manage_dirs_pattern(puppetagent_t, puppet_var_lib_t, puppet_var_lib_t)
+manage_files_pattern(puppetagent_t, puppet_var_lib_t, puppet_var_lib_t)
+files_search_var_lib(puppetagent_t)
 
-setattr_dirs_pattern(puppet_t, puppet_var_run_t, puppet_var_run_t)
-manage_files_pattern(puppet_t, puppet_var_run_t, puppet_var_run_t)
-files_pid_filetrans(puppet_t, puppet_var_run_t, { file dir })
+manage_dirs_pattern(puppetagent_t, puppet_var_run_t, puppet_var_run_t)
+manage_files_pattern(puppetagent_t, puppet_var_run_t, puppet_var_run_t)
+files_pid_filetrans(puppetagent_t, puppet_var_run_t, { file dir })
 
-allow puppet_t puppet_log_t:dir { create_dir_perms setattr_dir_perms };
-append_files_pattern(puppet_t, puppet_log_t, puppet_log_t)
-create_files_pattern(puppet_t, puppet_log_t, puppet_log_t)
-read_files_pattern(puppet_t, puppet_log_t, puppet_log_t)
-setattr_files_pattern(puppet_t, puppet_log_t, puppet_log_t)
-logging_log_filetrans(puppet_t, puppet_log_t, { file dir })
+create_dirs_pattern(puppetagent_t, var_log_t, puppet_log_t)
+create_files_pattern(puppetagent_t, puppet_log_t, puppet_log_t)
+append_files_pattern(puppetagent_t, puppet_log_t, puppet_log_t)
+logging_log_filetrans(puppetagent_t, puppet_log_t, { file dir })
 
-manage_dirs_pattern(puppet_t, puppet_tmp_t, puppet_tmp_t)
-manage_files_pattern(puppet_t, puppet_tmp_t, puppet_tmp_t)
-files_tmp_filetrans(puppet_t, puppet_tmp_t, { file dir })
+manage_dirs_pattern(puppetagent_t, puppet_tmp_t, puppet_tmp_t)
+manage_files_pattern(puppetagent_t, puppet_tmp_t, puppet_tmp_t)
+files_tmp_filetrans(puppetagent_t, puppet_tmp_t, { file dir })
 
-kernel_dontaudit_search_sysctl(puppet_t)
-kernel_dontaudit_search_kernel_sysctl(puppet_t)
-kernel_read_crypto_sysctls(puppet_t)
-kernel_read_kernel_sysctls(puppet_t)
-kernel_read_net_sysctls(puppet_t)
-kernel_read_network_state(puppet_t)
+kernel_dontaudit_search_sysctl(puppetagent_t)
+kernel_dontaudit_search_kernel_sysctl(puppetagent_t)
+kernel_read_system_state(puppetagent_t)
+kernel_read_crypto_sysctls(puppetagent_t)
+kernel_read_kernel_sysctls(puppetagent_t)
 
-corecmd_exec_bin(puppet_t)
-corecmd_exec_shell(puppet_t)
-corecmd_read_all_executables(puppet_t)
+corecmd_read_all_executables(puppetagent_t)
+corecmd_dontaudit_access_all_executables(puppetagent_t)
+corecmd_exec_bin(puppetagent_t)
+corecmd_exec_shell(puppetagent_t)
 
-corenet_all_recvfrom_netlabel(puppet_t)
-corenet_all_recvfrom_unlabeled(puppet_t)
-corenet_tcp_sendrecv_generic_if(puppet_t)
-corenet_tcp_sendrecv_generic_node(puppet_t)
+corenet_all_recvfrom_netlabel(puppetagent_t)
+corenet_tcp_sendrecv_generic_if(puppetagent_t)
+corenet_tcp_sendrecv_generic_node(puppetagent_t)
+corenet_tcp_bind_generic_node(puppetagent_t)
+corenet_tcp_connect_puppet_port(puppetagent_t)
+corenet_sendrecv_puppet_client_packets(puppetagent_t)
 
-corenet_sendrecv_puppet_client_packets(puppet_t)
-corenet_tcp_connect_puppet_port(puppet_t)
-corenet_tcp_sendrecv_puppet_port(puppet_t)
+dev_read_rand(puppetagent_t)
+dev_read_sysfs(puppetagent_t)
+dev_read_urand(puppetagent_t)
 
-dev_read_rand(puppet_t)
-dev_read_sysfs(puppet_t)
-dev_read_urand(puppet_t)
+domain_read_all_domains_state(puppetagent_t)
+domain_interactive_fd(puppetagent_t)
+domain_named_filetrans(puppetagent_t)
 
-domain_interactive_fd(puppet_t)
-domain_read_all_domains_state(puppet_t)
+files_manage_config_files(puppetagent_t)
+files_manage_config_dirs(puppetagent_t)
+files_manage_etc_dirs(puppetagent_t)
+files_manage_etc_files(puppetagent_t)
+files_read_usr_symlinks(puppetagent_t)
+files_relabel_config_dirs(puppetagent_t)
+files_relabel_config_files(puppetagent_t)
 
-files_manage_config_files(puppet_t)
-files_manage_config_dirs(puppet_t)
-files_manage_etc_dirs(puppet_t)
-files_manage_etc_files(puppet_t)
-files_read_usr_files(puppet_t)
-files_read_usr_symlinks(puppet_t)
-files_relabel_config_dirs(puppet_t)
-files_relabel_config_files(puppet_t)
-files_search_var_lib(puppet_t)
+selinux_set_all_booleans(puppetagent_t)
+selinux_set_generic_booleans(puppetagent_t)
+selinux_validate_context(puppetagent_t)
 
-selinux_get_fs_mount(puppet_t)
-selinux_search_fs(puppet_t)
-selinux_set_all_booleans(puppet_t)
-selinux_set_generic_booleans(puppet_t)
-selinux_validate_context(puppet_t)
+term_dontaudit_getattr_unallocated_ttys(puppetagent_t)
+term_dontaudit_getattr_all_ttys(puppetagent_t)
 
-term_dontaudit_getattr_unallocated_ttys(puppet_t)
-term_dontaudit_getattr_all_ttys(puppet_t)
+auth_use_nsswitch(puppetagent_t)
 
-init_all_labeled_script_domtrans(puppet_t)
-init_domtrans_script(puppet_t)
-init_read_utmp(puppet_t)
-init_signull_script(puppet_t)
+init_all_labeled_script_domtrans(puppetagent_t)
+init_domtrans_script(puppetagent_t)
+init_read_utmp(puppetagent_t)
+init_signull_script(puppetagent_t)
 
-logging_send_syslog_msg(puppet_t)
+logging_send_syslog_msg(puppetagent_t)
 
-miscfiles_read_hwdata(puppet_t)
-miscfiles_read_localization(puppet_t)
+miscfiles_read_hwdata(puppetagent_t)
 
-mount_domtrans(puppet_t)
+seutil_domtrans_setfiles(puppetagent_t)
+seutil_domtrans_semanage(puppetagent_t)
+seutil_read_file_contexts(puppetagent_t)
 
-seutil_domtrans_setfiles(puppet_t)
-seutil_domtrans_semanage(puppet_t)
+sysnet_run_ifconfig(puppetagent_t, system_r)
 
-sysnet_run_ifconfig(puppet_t, system_r)
-sysnet_use_ldap(puppet_t)
+usermanage_access_check_groupadd(puppetagent_t)
+usermanage_access_check_passwd(puppetagent_t)
+usermanage_access_check_useradd(puppetagent_t)
 
-tunable_policy(`puppet_manage_all_files',`
-	files_manage_non_auth_files(puppet_t)
+tunable_policy(`puppetagent_manage_all_files',`
+	files_manage_non_security_files(puppetagent_t)
 ')
 
 optional_policy(`
-	cfengine_read_lib_files(puppet_t)
+    mysql_stream_connect(puppetagent_t)
 ')
 
 optional_policy(`
-	consoletype_exec(puppet_t)
+    postgresql_stream_connect(puppetagent_t)
 ')
 
 optional_policy(`
-	hostname_exec(puppet_t)
+	cfengine_read_lib_files(puppetagent_t)
 ')
 
 optional_policy(`
-	mount_domtrans(puppet_t)
+	consoletype_exec(puppetagent_t)
 ')
 
 optional_policy(`
-	mta_send_mail(puppet_t)
+	hostname_exec(puppetagent_t)
 ')
 
 optional_policy(`
-	portage_domtrans(puppet_t)
-	portage_domtrans_fetch(puppet_t)
-	portage_domtrans_gcc_config(puppet_t)
+	mount_domtrans(puppetagent_t)
 ')
 
 optional_policy(`
-	files_rw_var_files(puppet_t)
+	mta_send_mail(puppetagent_t)
+')
 
-	rpm_domtrans(puppet_t)
-	rpm_manage_db(puppet_t)
-	rpm_manage_log(puppet_t)
+optional_policy(`
+	portage_domtrans(puppetagent_t)
+	portage_domtrans_fetch(puppetagent_t)
+	portage_domtrans_gcc_config(puppetagent_t)
 ')
 
 optional_policy(`
-	unconfined_domain(puppet_t)
+	files_rw_var_files(puppetagent_t)
+
+	rpm_domtrans(puppetagent_t)
+	rpm_manage_db(puppetagent_t)
+	rpm_manage_log(puppetagent_t)
 ')
 
 optional_policy(`
-	usermanage_domtrans_groupadd(puppet_t)
-	usermanage_domtrans_useradd(puppet_t)
+    unconfined_domain_noaudit(puppetagent_t)
 ')
 
 ########################################
 #
-# Ca local policy
+# PuppetCA personal policy
 #
 
 allow puppetca_t self:capability { dac_override setgid setuid };
 allow puppetca_t self:fifo_file rw_fifo_file_perms;
 
-allow puppetca_t puppet_etc_t:dir list_dir_perms;
-allow puppetca_t puppet_etc_t:file read_file_perms;
-allow puppetca_t puppet_etc_t:lnk_file read_lnk_file_perms;
+read_files_pattern(puppetca_t, puppet_etc_t, puppet_etc_t)
 
 allow puppetca_t puppet_var_lib_t:dir list_dir_perms;
 manage_files_pattern(puppetca_t, puppet_var_lib_t, puppet_var_lib_t)
@@ -221,6 +222,7 @@ allow puppetca_t puppet_log_t:dir search
 allow puppetca_t puppet_var_run_t:dir search_dir_perms;
 
 kernel_read_system_state(puppetca_t)
+# Maybe dontaudit this like we did with other puppet domains?
 kernel_read_kernel_sysctls(puppetca_t)
 
 corecmd_exec_bin(puppetca_t)
@@ -229,15 +231,12 @@ corecmd_exec_shell(puppetca_t)
 dev_read_urand(puppetca_t)
 dev_search_sysfs(puppetca_t)
 
-files_read_etc_files(puppetca_t)
-files_search_pids(puppetca_t)
 files_search_var_lib(puppetca_t)
 
 selinux_validate_context(puppetca_t)
 
 logging_search_logs(puppetca_t)
 
-miscfiles_read_localization(puppetca_t)
 miscfiles_read_generic_certs(puppetca_t)
 
 seutil_read_file_contexts(puppetca_t)
@@ -246,38 +245,47 @@ optional_policy(`
 	hostname_exec(puppetca_t)
 ')
 
+optional_policy(`
+	mta_sendmail_access_check(puppetca_t)
+')
+
+
 ########################################
 #
-# Master local policy
+# Pupper master personal policy
 #
 
 allow puppetmaster_t self:capability { dac_read_search dac_override setuid setgid fowner chown fsetid sys_tty_config };
 allow puppetmaster_t self:process { signal_perms getsched setsched };
 allow puppetmaster_t self:fifo_file rw_fifo_file_perms;
-allow puppetmaster_t self:netlink_route_socket nlmsg_write;
+allow puppetmaster_t self:netlink_route_socket create_netlink_socket_perms;
 allow puppetmaster_t self:socket create;
-allow puppetmaster_t self:tcp_socket { accept listen };
+allow puppetmaster_t self:tcp_socket create_stream_socket_perms;
+allow puppetmaster_t self:udp_socket create_socket_perms;
 
-allow puppetmaster_t puppet_etc_t:dir list_dir_perms;
-allow puppetmaster_t puppet_etc_t:file read_file_perms;
-allow puppetmaster_t puppet_etc_t:lnk_file read_lnk_file_perms;
-
-allow puppetmaster_t puppet_log_t:dir setattr_dir_perms;
-append_files_pattern(puppetmaster_t, puppet_log_t, puppet_log_t)
-create_files_pattern(puppetmaster_t, puppet_log_t, puppet_log_t)
-setattr_files_pattern(puppetmaster_t, puppet_log_t, puppet_log_t)
-logging_log_filetrans(puppetmaster_t, puppet_log_t, { file dir })
+list_dirs_pattern(puppetmaster_t, puppet_etc_t, puppet_etc_t)
+read_files_pattern(puppetmaster_t, puppet_etc_t, puppet_etc_t)
 
-allow puppetmaster_t puppet_var_lib_t:dir { manage_dir_perms relabel_dir_perms };
-allow puppetmaster_t puppet_var_lib_t:file { manage_file_perms relabel_file_perms };
+allow puppetmaster_t puppet_log_t:dir { rw_dir_perms setattr_dir_perms };
+allow puppetmaster_t puppet_log_t:file { rw_file_perms create_file_perms setattr_file_perms };
+logging_log_filetrans(puppetmaster_t, puppet_log_t, { file dir })
+allow puppetmaster_t puppet_log_t:file relabel_file_perms;
 
-allow puppetmaster_t puppet_var_run_t:dir { create_dir_perms setattr_dir_perms relabel_dir_perms };
-allow puppetmaster_t puppet_var_run_t:file manage_file_perms;
+manage_dirs_pattern(puppetmaster_t, puppet_var_lib_t, puppet_var_lib_t)
+manage_files_pattern(puppetmaster_t, puppet_var_lib_t, puppet_var_lib_t)
+allow puppetmaster_t puppet_var_lib_t:dir relabel_dir_perms;
+allow puppetmaster_t puppet_var_lib_t:file relabel_file_perms;
+
+setattr_dirs_pattern(puppetmaster_t, puppet_var_run_t, puppet_var_run_t)
+create_dirs_pattern(puppetmaster_t, puppet_var_run_t, puppet_var_run_t)
+manage_files_pattern(puppetmaster_t, puppet_var_run_t, puppet_var_run_t)
 files_pid_filetrans(puppetmaster_t, puppet_var_run_t, { file dir })
+allow puppetmaster_t puppet_var_run_t:dir relabel_dir_perms;
 
-allow puppetmaster_t puppetmaster_tmp_t:dir { manage_dir_perms relabel_dir_perms };
-allow puppetmaster_t puppetmaster_tmp_t:file manage_file_perms;
+manage_dirs_pattern(puppetmaster_t, puppetmaster_tmp_t, puppetmaster_tmp_t)
+manage_files_pattern(puppetmaster_t, puppetmaster_tmp_t, puppetmaster_tmp_t)
 files_tmp_filetrans(puppetmaster_t, puppetmaster_tmp_t, { file dir })
+allow puppetmaster_t puppet_tmp_t:dir relabel_dir_perms;
 
 kernel_dontaudit_search_kernel_sysctl(puppetmaster_t)
 kernel_read_network_state(puppetmaster_t)
@@ -289,23 +297,24 @@ corecmd_exec_bin(puppetmaster_t)
 corecmd_exec_shell(puppetmaster_t)
 
 corenet_all_recvfrom_netlabel(puppetmaster_t)
-corenet_all_recvfrom_unlabeled(puppetmaster_t)
 corenet_tcp_sendrecv_generic_if(puppetmaster_t)
 corenet_tcp_sendrecv_generic_node(puppetmaster_t)
 corenet_tcp_bind_generic_node(puppetmaster_t)
-
-corenet_sendrecv_puppet_server_packets(puppetmaster_t)
 corenet_tcp_bind_puppet_port(puppetmaster_t)
-corenet_tcp_sendrecv_puppet_port(puppetmaster_t)
+corenet_sendrecv_puppet_server_packets(puppetmaster_t)
+corenet_tcp_connect_ntop_port(puppetmaster_t)
+
+# This needs investigation. Puppermasterd is confirmed to bind udp sockets to random high ports.
+corenet_udp_bind_generic_node(puppetmaster_t)
+corenet_udp_bind_generic_port(puppetmaster_t)
 
 dev_read_rand(puppetmaster_t)
 dev_read_urand(puppetmaster_t)
 dev_search_sysfs(puppetmaster_t)
 
-domain_obj_id_change_exemption(puppetmaster_t)
 domain_read_all_domains_state(puppetmaster_t)
+domain_obj_id_change_exemption(puppetmaster_t)
 
-files_read_usr_files(puppetmaster_t)
 
 selinux_validate_context(puppetmaster_t)
 
@@ -314,26 +323,31 @@ auth_use_nsswitch(puppetmaster_t)
 logging_send_syslog_msg(puppetmaster_t)
 
 miscfiles_read_generic_certs(puppetmaster_t)
-miscfiles_read_localization(puppetmaster_t)
 
 seutil_read_file_contexts(puppetmaster_t)
 
 sysnet_run_ifconfig(puppetmaster_t, system_r)
 
+mta_send_mail(puppetmaster_t)
+
 optional_policy(`
-	hostname_exec(puppetmaster_t)
+	tunable_policy(`puppetmaster_use_db',`
+		mysql_stream_connect(puppetmaster_t)
+	')
 ')
 
 optional_policy(`
-	mta_send_mail(puppetmaster_t)
+	tunable_policy(`puppetmaster_use_db',`
+		postgresql_stream_connect(puppetmaster_t)
+	')
 ')
 
 optional_policy(`
-	mysql_stream_connect(puppetmaster_t)
+	systemd_dbus_chat_timedated(puppetmaster_t)
 ')
 
 optional_policy(`
-	postgresql_stream_connect(puppetmaster_t)
+	hostname_exec(puppetmaster_t)
 ')
 
 optional_policy(`
@@ -342,3 +356,9 @@ optional_policy(`
 	rpm_exec(puppetmaster_t)
 	rpm_read_db(puppetmaster_t)
 ')
+
+optional_policy(`
+	usermanage_access_check_groupadd(puppetmaster_t)
+	usermanage_access_check_passwd(puppetmaster_t)
+	usermanage_access_check_useradd(puppetmaster_t)
+')
Index: serefpolicy-contrib-20140730/pwauth.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/pwauth.fc
+++ serefpolicy-contrib-20140730/pwauth.fc
@@ -1,3 +1,3 @@
-/usr/bin/pwauth	--	gen_context(system_u:object_r:pwauth_exec_t,s0)
+/usr/bin/pwauth		--	gen_context(system_u:object_r:pwauth_exec_t,s0)
 
-/var/run/pwauth\.lock	--	gen_context(system_u:object_r:pwauth_var_run_t,s0)
+/var/run/pwauth.lock	--	gen_context(system_u:object_r:pwauth_var_run_t,s0)
Index: serefpolicy-contrib-20140730/pwauth.if
===================================================================
--- serefpolicy-contrib-20140730.orig/pwauth.if
+++ serefpolicy-contrib-20140730/pwauth.if
@@ -1,72 +1,74 @@
-## <summary>External plugin for mod_authnz_external authenticator.</summary>
+
+## <summary>policy for pwauth</summary>
 
 ########################################
 ## <summary>
-##	Role access for pwauth.
+##	Transition to pwauth.
 ## </summary>
-## <param name="role">
-##	<summary>
-##	Role allowed access.
-##	</summary>
-## </param>
 ## <param name="domain">
-##	<summary>
-##	User domain for the role.
-##	</summary>
+## <summary>
+##	Domain allowed to transition.
+## </summary>
 ## </param>
 #
-interface(`pwauth_role',`
+interface(`pwauth_domtrans',`
 	gen_require(`
-		type pwauth_t;
+		type pwauth_t, pwauth_exec_t;
 	')
 
-	pwauth_run($2, $1)
-
-	ps_process_pattern($2, pwauth_t)
-	allow $2 pwauth_t:process { ptrace signal_perms };
+	corecmd_search_bin($1)
+	domtrans_pattern($1, pwauth_exec_t, pwauth_t)
 ')
 
 ########################################
 ## <summary>
-##	Execute pwauth in the pwauth domain.
+##	Execute pwauth in the pwauth domain, and
+##	allow the specified role the pwauth domain.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed to transition.
+##	Domain allowed to transition
+##	</summary>
+## </param>
+## <param name="role">
+##	<summary>
+##	The role to be allowed the pwauth domain.
 ##	</summary>
 ## </param>
 #
-interface(`pwauth_domtrans',`
+interface(`pwauth_run',`
 	gen_require(`
-		type pwauth_t, pwauth_exec_t;
+		type pwauth_t;
 	')
 
-	corecmd_search_bin($1)
-	domtrans_pattern($1, pwauth_exec_t, pwauth_t)
+	pwauth_domtrans($1)
+	role $2 types pwauth_t;
 ')
 
 ########################################
 ## <summary>
-##	Execute pwauth in the pwauth
-##	domain, and allow the specified
-##	role the pwauth domain.
+##	Role access for pwauth
 ## </summary>
-## <param name="domain">
+## <param name="role">
 ##	<summary>
-##	Domain allowed to transition.
+##	Role allowed access
 ##	</summary>
 ## </param>
-## <param name="role">
+## <param name="domain">
 ##	<summary>
-##	Role allowed access.
+##	User domain for the role
 ##	</summary>
 ## </param>
 #
-interface(`pwauth_run',`
+interface(`pwauth_role',`
 	gen_require(`
-		attribute_role pwauth_roles;
+		type pwauth_t;
 	')
 
-	pwauth_domtrans($1)
-	roleattribute $2 pwauth_roles;
+	role $1 types pwauth_t;
+
+	pwauth_domtrans($2)
+
+	ps_process_pattern($2, pwauth_t)
+	allow $2 pwauth_t:process signal;
 ')
Index: serefpolicy-contrib-20140730/pwauth.te
===================================================================
--- serefpolicy-contrib-20140730.orig/pwauth.te
+++ serefpolicy-contrib-20140730/pwauth.te
@@ -5,26 +5,23 @@ policy_module(pwauth, 1.0.0)
 # Declarations
 #
 
-attribute_role pwauth_roles;
-roleattribute system_r pwauth_roles;
-
 type pwauth_t;
 type pwauth_exec_t;
 application_domain(pwauth_t, pwauth_exec_t)
-role pwauth_roles types pwauth_t;
+role system_r types pwauth_t;
 
 type pwauth_var_run_t;
 files_pid_file(pwauth_var_run_t)
 
 ########################################
 #
-# Local policy
+# pwauth local policy
 #
-
 allow pwauth_t self:capability setuid;
 allow pwauth_t self:process setrlimit;
+
 allow pwauth_t self:fifo_file manage_fifo_file_perms;
-allow pwauth_t self:unix_stream_socket { accept listen };
+allow pwauth_t self:unix_stream_socket create_stream_socket_perms;
 
 manage_files_pattern(pwauth_t, pwauth_var_run_t, pwauth_var_run_t)
 files_pid_filetrans(pwauth_t, pwauth_var_run_t, file)
@@ -33,10 +30,10 @@ domain_use_interactive_fds(pwauth_t)
 
 auth_domtrans_chkpwd(pwauth_t)
 auth_use_nsswitch(pwauth_t)
+auth_read_shadow(pwauth_t)
+auth_rw_lastlog(pwauth_t)
 
 init_read_utmp(pwauth_t)
 
 logging_send_syslog_msg(pwauth_t)
 logging_send_audit_msgs(pwauth_t)
-
-miscfiles_read_localization(pwauth_t)
Index: serefpolicy-contrib-20140730/pxe.te
===================================================================
--- serefpolicy-contrib-20140730.orig/pxe.te
+++ serefpolicy-contrib-20140730/pxe.te
@@ -50,15 +50,12 @@ dev_read_sysfs(pxe_t)
 
 domain_use_interactive_fds(pxe_t)
 
-files_read_etc_files(pxe_t)
 
 fs_getattr_all_fs(pxe_t)
 fs_search_auto_mountpoints(pxe_t)
 
 logging_send_syslog_msg(pxe_t)
 
-miscfiles_read_localization(pxe_t)
-
 userdom_dontaudit_use_unpriv_user_fds(pxe_t)
 userdom_dontaudit_search_user_home_dirs(pxe_t)
 
Index: serefpolicy-contrib-20140730/pyzor.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/pyzor.fc
+++ serefpolicy-contrib-20140730/pyzor.fc
@@ -1,12 +1,13 @@
-HOME_DIR/\.pyzor(/.*)?	gen_context(system_u:object_r:pyzor_home_t,s0)
-
-/etc/pyzor(/.*)?	gen_context(system_u:object_r:pyzor_etc_t, s0)
-
+/etc/pyzor(/.*)?		gen_context(system_u:object_r:pyzor_etc_t, s0)
 /etc/rc\.d/init\.d/pyzord	--	gen_context(system_u:object_r:pyzord_initrc_exec_t,s0)
 
-/usr/bin/pyzor	--	gen_context(system_u:object_r:pyzor_exec_t,s0)
-/usr/bin/pyzord	--	gen_context(system_u:object_r:pyzord_exec_t,s0)
+HOME_DIR/\.pyzor(/.*)?		gen_context(system_u:object_r:pyzor_home_t,s0)
+HOME_DIR/\.spamd(/.*)?		gen_context(system_u:object_r:pyzor_home_t,s0)
+/root/\.pyzor(/.*)?		gen_context(system_u:object_r:pyzor_home_t,s0)
+/root/\.spamd(/.*)?		gen_context(system_u:object_r:pyzor_home_t,s0)
 
-/var/lib/pyzord(/.*)?	gen_context(system_u:object_r:pyzor_var_lib_t,s0)
+/usr/bin/pyzor		--	gen_context(system_u:object_r:pyzor_exec_t,s0)
+/usr/bin/pyzord		--	gen_context(system_u:object_r:pyzord_exec_t,s0)
 
+/var/lib/pyzord(/.*)?		gen_context(system_u:object_r:pyzor_var_lib_t,s0)
 /var/log/pyzord\.log.*	--	gen_context(system_u:object_r:pyzord_log_t,s0)
